OpenTTD Source: BaseStation Struct Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Static Public Member Functions | Data Fields | Private Member Functions
BaseStation Struct Referenceabstract

Base class for all station-ish types. More...

`#include <base_station_base.h>`

Inheritance diagram for BaseStation:

## Public Member Functions
| BaseStation (TileIndex tile)
| Initialize the base station.
virtual bool | TileBelongsToRailStation (TileIndex tile) const =0
| Check whether a specific tile belongs to this station.
virtual uint32_t | GetNewGRFVariable (const struct ResolverObject &object, uint8_t variable, uint8_t parameter, bool &available) const =0
| Helper function to get a NewGRF variable that isn't implemented by the base class.
virtual void | UpdateVirtCoord ()=0
| Update the coordinated of the sign (as shown in the viewport).
const std::string & | GetCachedName () const
virtual void | MoveSign (TileIndex new_xy)
virtual TileArea | GetTileArea (StationType type) const =0
| Get the tile area for a given station type.
virtual uint | GetPlatformLength (TileIndex tile) const =0
| Obtain the length of a platform.
virtual uint | GetPlatformLength (TileIndex tile, DiagDirection dir) const =0
| Determines the REMAINING length of a platform, starting at (and including) the given tile.
bool | IsInUse () const
| Check whether the base station currently is in use; in use means that it is not scheduled for deletion and that it still has some facilities left.
uint8_t | GetRoadStopRandomBits (TileIndex tile) const
uint8_t | GetRoadStopAnimationFrame (TileIndex tile) const
void | SetRoadStopRandomBits (TileIndex tile, uint8_t random_bits)
bool | SetRoadStopAnimationFrame (TileIndex tile, uint8_t frame)
void | RemoveRoadStopTileData (TileIndex tile)
Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_station_pool >
void * | operator new (size_t size)
| Allocates space for new Titem.
void * | operator new (size_t size, Tindex index)
| Allocates space for new Titem with given index.
void * | operator new (size_t, void *ptr)
| Allocates space for new Titem at given memory address.
void | operator delete (void *p, size_t size)
| Marks Titem as free.

## Static Public Member Functions
static BaseStation * | GetByTile (TileIndex tile)
| Get the base station belonging to a specific tile.
static void | PostDestructor (size_t index)
| Invalidating of the JoinStation window has to be done after removing item from the pool.
Static Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_station_pool >
static bool | CanAllocateItem (size_t n=1)
| Helper functions so we can use PoolItem::Function() instead of _poolitem_pool.Function()
static bool | CleaningPool ()
| Returns current state of pool cleaning - yes or no.
static bool | IsValidID (auto index)
| Tests whether given index can be used to get valid (non-nullptr) Titem.
static Titem * | Get (auto index)
| Returns Titem with given index.
static Titem * | GetIfValid (auto index)
| Returns Titem with given index.
static size_t | GetPoolSize ()
| Returns first unused index.
static size_t | GetNumItems ()
| Returns number of valid items in the pool.
static void | PostDestructor (size_t index)
| Dummy function called after destructor of each member.
static Pool::IterateWrapper< Titem > | Iterate (size_t from=0)
| Returns an iterable ensemble of all valid Titem.

## Data Fields
TileIndex | xy = INVALID_TILE
| Base tile of the station.
TrackedViewportSign | sign {}
| NOSAVE: Dimensions of sign.
uint8_t | delete_ctr = 0
| Delete counter. If greater than 0 then it is decremented until it reaches 0; the waypoint is then is deleted.
std::string | name {}
| Custom name.
StringID | string_id = INVALID_STRING_ID
| Default name (town area) of station.
std::string | cached_name
| NOSAVE: Cache of the resolved name of the station, if not using a custom name.
Town * | town = nullptr
| The town this station is associated with.
Owner | owner = INVALID_OWNER
| The owner of this station.
StationFacilities | facilities {}
| The facilities that this station has.
std::vector< SpecMapping< StationSpec > > | speclist {}
| List of rail station specs of this station.
std::vector< SpecMapping< RoadStopSpec > > | roadstop_speclist {}
| List of road stop specs of this station.
TimerGameCalendar::Date | build_date {}
| Date of construction.
uint16_t | random_bits = 0
| Random bits assigned to this station.
StationRandomTriggers | waiting_random_triggers
| Waiting triggers (NewGRF), shared by all station parts/tiles, road stops, ... essentially useless and broken by design.
StationAnimationTriggers | cached_anim_triggers
| NOSAVE: Combined animation trigger bitmask, used to determine if trigger processing should happen.
StationAnimationTriggers | cached_roadstop_anim_triggers
| NOSAVE: Combined animation trigger bitmask for road stops, used to determine if trigger processing should happen.
CargoTypes | cached_cargo_triggers {}
| NOSAVE: Combined cargo trigger bitmask.
CargoTypes | cached_roadstop_cargo_triggers {}
| NOSAVE: Combined cargo trigger bitmask for road stops.
TileArea | train_station {INVALID_TILE, 0, 0}
| Tile area the train 'station' part covers.
StationRect | rect {}
| NOSAVE: Station spread out rectangle maintained by StationRect::xxx() functions.
std::vector< RoadStopTileData > | custom_roadstop_tile_data {}
| List of custom road stop tile data.
Data Fields inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_station_pool >
Tindex | index
| Index of this pool item.

## Private Member Functions
bool | SetRoadStopTileData (TileIndex tile, uint8_t data, bool animation)
void | FillCachedName () const

## Additional Inherited Members
Public Types inherited from Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_station_pool >
typedef struct Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache > | Pool
| Type of the pool this item is going to be part of.

## Detailed Description

Base class for all station-ish types.

Definition at line 58 of file base_station_base.h.

## Constructor & Destructor Documentation

## ◆ BaseStation()

BaseStation::BaseStation | ( | TileIndex | tile | ) |
| inline

Initialize the base station.

Parameters

  tile | The location of the station sign

Definition at line 92 of file base_station_base.h.

## ◆ ~BaseStation()

BaseStation::~BaseStation | ( |  | ) |
| virtual

Definition at line 52 of file station.cpp.

## Member Function Documentation

## ◆ FillCachedName()

void BaseStation::FillCachedName | ( |  | ) | const
| private

Definition at line 471 of file station_cmd.cpp.

## ◆ GetByTile()

static BaseStation * BaseStation::GetByTile | ( | TileIndex | tile | ) |
| inlinestatic

Get the base station belonging to a specific tile.

Parameters

  tile | The tile to get the base station from.

Returns
  the station associated with that tile.

Definition at line 160 of file base_station_base.h.

References Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_station_pool >::Get(), and GetStationIndex().

Referenced by AfterLoadGame(), AircraftEventHandler_InHangar(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::CanEnterNewTile(), CheckForDockingTile(), CmdBuildAircraft(), DisasterTick_Zeppeliner(), FloodVehicleProc(), FloodVehicles(), RoadStop::GetByTile(), GetOrderCmdFromTile(), NIHStation::GetParent(), NIHRoadStop::GetParent(), RoadStopScopeResolver::GetVariable(), StationScopeResolver::GetVariable(), GetVehiclePosOnBuild(), IsHangar(), CYapfCostRailT< Types >::PfCalcCost(), RemoveAirport(), RemoveBuoy(), RemoveDock(), RemoveRailStation(), RemoveRailWaypoint(), RemoveRoadStop(), RemoveRoadWaypointStop(), CYapfReserveTrack< Types >::ReserveRailStationPlatform(), CYapfReserveTrack< Types >::ReserveSingleTrack(), NIHStation::Resolve(), NIHAirportTile::Resolve(), and TryReserveRailTrack().

## ◆ GetCachedName()

const std::string & BaseStation::GetCachedName | ( |  | ) | const
| inline

Definition at line 118 of file base_station_base.h.

## ◆ GetNewGRFVariable()

virtual uint32_t BaseStation::GetNewGRFVariable | ( | const struct ResolverObject & | object,
|  | uint8_t | variable,
|  | uint8_t | parameter,
|  | bool & | available
| ) |  | const
| pure virtual

Helper function to get a NewGRF variable that isn't implemented by the base class.

Parameters

  object | the resolver object related to this query
  variable | that is queried
  parameter | parameter for that variable
  available | will return false if ever the variable asked for does not exist

Returns
  the value stored in the corresponding variable

Implemented in Waypoint.

Referenced by RoadStopScopeResolver::GetVariable(), and StationScopeResolver::GetVariable().

## ◆ GetPlatformLength() [1/2]

virtual uint BaseStation::GetPlatformLength | ( | TileIndex | tile | ) | const
| pure virtual

Obtain the length of a platform.

Precondition
  tile must be a rail station tile

Parameters

  tile | A tile that contains the platform in question

Returns
  The length of the platform

Implemented in Station, and Waypoint.

Referenced by CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::CanEnterNewTile(), and CYapfCostRailT< Types >::PfCalcCost().

## ◆ GetPlatformLength() [2/2]

virtual uint BaseStation::GetPlatformLength | ( | TileIndex | tile,
|  | DiagDirection | dir
| ) |  | const
| pure virtual

Determines the REMAINING length of a platform, starting at (and including) the given tile.

Parameters

  tile | the tile from which to start searching. Must be a rail station tile
  dir | The direction in which to search.

Returns
  The platform length

Implemented in Station, and Waypoint.

## ◆ GetRoadStopAnimationFrame()

uint8_t BaseStation::GetRoadStopAnimationFrame | ( | TileIndex | tile | ) | const
| inline

Definition at line 184 of file base_station_base.h.

## ◆ GetRoadStopRandomBits()

uint8_t BaseStation::GetRoadStopRandomBits | ( | TileIndex | tile | ) | const
| inline

Definition at line 176 of file base_station_base.h.

## ◆ GetTileArea()

virtual TileArea BaseStation::GetTileArea | ( | StationType | type | ) | const
| pure virtual

Get the tile area for a given station type.

Parameters

  type | the type of the area

Returns
  The tile area.

Implemented in Station, and Waypoint.

Referenced by CalcClosestStationTile(), and GetRailTileArea().

## ◆ IsInUse()

bool BaseStation::IsInUse | ( |  | ) | const
| inline

Check whether the base station currently is in use; in use means that it is not scheduled for deletion and that it still has some facilities left.

Returns
  true if still in use

Definition at line 171 of file base_station_base.h.

References Airport, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Any(), BusStop, Dock, facilities, Train, and TruckStop.

Referenced by CmdBuildRailWaypoint(), CmdBuildRoadWaypoint(), DeleteStationIfEmpty(), WaypointWindow::GetCenterTile(), GetClosestDeletedStation(), WaypointWindow::OnInvalidateData(), WaypointWindow::OnPaint(), StationHandleBigTick(), and UpdateStationAcceptance().

## ◆ MoveSign()

virtual void BaseStation::MoveSign | ( | TileIndex | new_xy | ) |
| inlinevirtual

Reimplemented in Station, and Waypoint.

Definition at line 125 of file base_station_base.h.

## ◆ PostDestructor()

void BaseStation::PostDestructor | ( | size_t | index | ) |
| static

Invalidating of the JoinStation window has to be done after removing item from the pool.

Definition at line 170 of file station.cpp.

References InvalidateWindowData(), and WC_SELECT_STATION.

## ◆ RemoveRoadStopTileData()

void BaseStation::RemoveRoadStopTileData | ( | TileIndex | tile | ) |

Definition at line 193 of file station.cpp.

## ◆ SetRoadStopAnimationFrame()

bool BaseStation::SetRoadStopAnimationFrame | ( | TileIndex | tile,
|  | uint8_t | frame
| ) |  |
| inline

Definition at line 197 of file base_station_base.h.

## ◆ SetRoadStopRandomBits()

void BaseStation::SetRoadStopRandomBits | ( | TileIndex | tile,
|  | uint8_t | random_bits
| ) |  |
| inline

Definition at line 196 of file base_station_base.h.

## ◆ SetRoadStopTileData()

bool BaseStation::SetRoadStopTileData | ( | TileIndex | tile,
|  | uint8_t | data,
|  | bool | animation
| ) |  |
| private

Definition at line 175 of file station.cpp.

## ◆ TileBelongsToRailStation()

virtual bool BaseStation::TileBelongsToRailStation | ( | TileIndex | tile | ) | const
| pure virtual

Check whether a specific tile belongs to this station.

Parameters

  tile | the tile to check

Returns
  true if the tile belongs to this station

Implemented in Station, and Waypoint.

Referenced by DeallocateSpecFromStation(), StationScopeResolver::GetVariable(), StationUsesDefaultType(), and TriggerStationRandomisation().

## ◆ UpdateVirtCoord()

virtual void BaseStation::UpdateVirtCoord | ( |  | ) |
| pure virtual

Update the coordinated of the sign (as shown in the viewport).

Implemented in Station, and Waypoint.

References cached_name, and name.

Referenced by RemoveFromRailBaseStation().

## Field Documentation

## ◆ build_date

TimerGameCalendar::Date BaseStation::build_date {}

Date of construction.

Definition at line 74 of file base_station_base.h.

Referenced by Station::AddFacility(), CmdBuildBuoy(), CmdBuildRailWaypoint(), CmdBuildRoadWaypoint(), AirportScopeResolver::GetVariable(), RoadStopScopeResolver::GetVariable(), StationScopeResolver::GetVariable(), MoveBuoysToWaypoints(), and MoveWaypointsToBaseStations().

## ◆ cached_anim_triggers

StationAnimationTriggers BaseStation::cached_anim_triggers

NOSAVE: Combined animation trigger bitmask, used to determine if trigger processing should happen.

Definition at line 78 of file base_station_base.h.

Referenced by CmdBuildRailStation(), DeallocateSpecFromStation(), and StationUpdateCachedTriggers().

## ◆ cached_cargo_triggers

CargoTypes BaseStation::cached_cargo_triggers {}

NOSAVE: Combined cargo trigger bitmask.

Definition at line 80 of file base_station_base.h.

Referenced by DeallocateSpecFromStation(), StationUpdateCachedTriggers(), and TriggerStationRandomisation().

## ◆ cached_name

std::string BaseStation::cached_name
| mutable

NOSAVE: Cache of the resolved name of the station, if not using a custom name.

Definition at line 65 of file base_station_base.h.

Referenced by CmdRenameStation(), and UpdateVirtCoord().

## ◆ cached_roadstop_anim_triggers

StationAnimationTriggers BaseStation::cached_roadstop_anim_triggers

NOSAVE: Combined animation trigger bitmask for road stops, used to determine if trigger processing should happen.

Definition at line 79 of file base_station_base.h.

Referenced by CmdBuildRoadStop(), CmdBuildRoadWaypoint(), DeallocateSpecFromRoadStop(), and RoadStopUpdateCachedTriggers().

## ◆ cached_roadstop_cargo_triggers

CargoTypes BaseStation::cached_roadstop_cargo_triggers {}

NOSAVE: Combined cargo trigger bitmask for road stops.

Definition at line 81 of file base_station_base.h.

Referenced by DeallocateSpecFromRoadStop(), RoadStopUpdateCachedTriggers(), and TriggerRoadStopRandomisation().

## ◆ custom_roadstop_tile_data

std::vector<RoadStopTileData> BaseStation::custom_roadstop_tile_data {}

List of custom road stop tile data.

Definition at line 86 of file base_station_base.h.

Referenced by DeallocateSpecFromRoadStop(), SlRoadStopTileData::GetVector(), and TriggerRoadStopRandomisation().

## ◆ delete_ctr

uint8_t BaseStation::delete_ctr = 0

Delete counter. If greater than 0 then it is decremented until it reaches 0; the waypoint is then is deleted.

Definition at line 61 of file base_station_base.h.

Referenced by CmdBuildRailWaypoint(), CmdBuildRoadWaypoint(), DeleteStationIfEmpty(), MoveBuoysToWaypoints(), MoveWaypointsToBaseStations(), RemoveBuoy(), and StationHandleBigTick().

## ◆ facilities

StationFacilities BaseStation::facilities {}

The facilities that this station has.

Definition at line 69 of file base_station_base.h.

Referenced by Station::AddFacility(), AirportMaintenanceCost(), CanVehicleUseStation(), CmdBuildAirport(), CmdBuildBuoy(), CmdBuildRailWaypoint(), CmdBuildRoadWaypoint(), CmdInsertOrder(), CmdOpenCloseAirport(), CompanyStationsWindow::DrawWidget(), SelectStationWindow< T >::DrawWidget(), GetOrderCmdFromTile(), Train::GetOrderStationLocation(), AirportScopeResolver::GetVariable(), RoadStopScopeResolver::GetVariable(), StationScopeResolver::GetVariable(), GetVehicleCannotUseStationReason(), StationViewWindow::GetWidgetString(), SpecializedStation< T, Tis_waypoint >::IsExpected(), IsInUse(), Waypoint::IsSingleTile(), MoveBuoysToWaypoints(), MoveWaypointsToBaseStations(), StationViewWindow::OnPaint(), RemoveAirport(), RemoveBuoy(), RemoveDock(), RemoveFromRailBaseStation(), RemoveRoadStop(), RemoveRoadWaypointStop(), SpecializedStation< T, Tis_waypoint >::SpecializedStation(), StationHandleBigTick(), CompanyStationsWindow::StationTypeSorter(), UpdateStationAcceptance(), Station::UpdateVirtCoord(), and SelectStationWindow< T >::UpdateWidgetSize().

## ◆ name

std::string BaseStation::name {}

Custom name.

Definition at line 63 of file base_station_base.h.

Referenced by CmdRenameStation(), CmdRenameWaypoint(), FormatString(), MoveBuoysToWaypoints(), MoveWaypointsToBaseStations(), and UpdateVirtCoord().

## ◆ owner

Owner BaseStation::owner = INVALID_OWNER

The owner of this station.

Definition at line 68 of file base_station_base.h.

Referenced by Station::AddFacility(), LinkGraphOverlay::AddLinks(), AddNearbyStation(), AfterLoadGame(), Station::AfterStationTileSetChange(), AirportMaintenanceCost(), CmdBuildAirport(), CmdBuildBuoy(), CmdBuildDock(), CmdBuildRailStation(), CmdBuildRailWaypoint(), CmdBuildRoadStop(), CmdBuildRoadWaypoint(), CmdInsertOrder(), CmdMoveStationName(), CmdMoveWaypointName(), CmdOpenCloseAirport(), CmdRenameStation(), CmdRenameWaypoint(), DeleteStationIfEmpty(), DeliverGoodsToIndustry(), StationViewWindow::DrawCargoRatings(), LinkGraphOverlay::DrawStationDots(), CompanyStationsWindow::DrawWidget(), OrderList::FreeChain(), GetClosestDeletedStation(), GetOrderCmdFromTile(), RoadStopScopeResolver::GetVariable(), StationScopeResolver::GetVariable(), OrderList::InsertOrderAt(), LoadUnloadVehicle(), MayLoadUnderExclusiveRights(), ModifyStationRatingAround(), MoveBuoysToWaypoints(), MoveWaypointsToBaseStations(), CompanyStationsWindow::OnClick(), StationViewWindow::OnClick(), WaypointWindow::OnClick(), StationViewWindow::OnPaint(), LinkGraphOverlay::RebuildCache(), RemoveAirport(), RemoveDock(), RemoveRoadStop(), RemoveRoadWaypointStop(), UpdateStationAcceptance(), UpdateStationRating(), UpdateTownRating(), WaypointWindow::WaypointWindow(), and Station::~Station().

## ◆ random_bits

uint16_t BaseStation::random_bits = 0

Random bits assigned to this station.

Definition at line 76 of file base_station_base.h.

Referenced by Station::AddFacility(), AirportScopeResolver::GetRandomBits(), AirportTileScopeResolver::GetRandomBits(), RoadStopScopeResolver::GetRandomBits(), StationScopeResolver::GetRandomBits(), TriggerRoadStopRandomisation(), and TriggerStationRandomisation().

## ◆ rect

StationRect BaseStation::rect {}

NOSAVE: Station spread out rectangle maintained by StationRect::xxx() functions.

Definition at line 84 of file base_station_base.h.

Referenced by AddNearbyStation(), AfterLoadGame(), CheckSubsidised(), CmdBuildAirport(), CmdBuildBuoy(), CmdBuildDock(), CmdBuildRailStation(), CmdBuildRailWaypoint(), CmdBuildRoadStop(), CmdBuildRoadWaypoint(), CmdMoveStationName(), CmdMoveWaypointName(), Station::GetCatchmentRect(), SmallMapWindow::GetStationMiddle(), GetTileHighlightType(), MoveBuoysToWaypoints(), MoveWaypointsToBaseStations(), LinkGraphOverlay::RebuildCache(), Station::RecomputeCatchment(), RemoveAirport(), RemoveBuoy(), RemoveDock(), RemoveRoadStop(), RemoveRoadWaypointStop(), and UpdateStationAcceptance().

## ◆ roadstop_speclist

std::vector<SpecMapping<RoadStopSpec> > BaseStation::roadstop_speclist {}

List of road stop specs of this station.

Definition at line 72 of file base_station_base.h.

Referenced by AllocateSpecToRoadStop(), AssignSpecToRoadStop(), DeallocateSpecFromRoadStop(), and RoadStopScopeResolver::GetVariable().

## ◆ sign

TrackedViewportSign BaseStation::sign {}

NOSAVE: Dimensions of sign.

Definition at line 60 of file base_station_base.h.

Referenced by Station::UpdateVirtCoord(), Waypoint::UpdateVirtCoord(), and Station::~Station().

## ◆ speclist

std::vector<SpecMapping<StationSpec> > BaseStation::speclist {}

List of rail station specs of this station.

Definition at line 71 of file base_station_base.h.

Referenced by AllocateSpecToStation(), AssignSpecToStation(), DeallocateSpecFromStation(), StationScopeResolver::GetVariable(), and Station::MarkTilesDirty().

## ◆ string_id

StringID BaseStation::string_id = INVALID_STRING_ID

Default name (town area) of station.

Definition at line 64 of file base_station_base.h.

Referenced by CmdBuildBuoy(), CmdBuildRailWaypoint(), CmdBuildRoadWaypoint(), FormatString(), StationScopeResolver::GetVariable(), Waypoint::IsOfType(), MoveBuoysToWaypoints(), MoveWaypointsToBaseStations(), and WaypointWindow::WaypointWindow().

## ◆ town

Town* BaseStation::town = nullptr

The town this station is associated with.

Definition at line 67 of file base_station_base.h.

Referenced by AddCargoDelivery(), AfterLoadGame(), CmdBuildAirport(), CmdBuildBuoy(), CmdBuildRailWaypoint(), CmdBuildRoadWaypoint(), DeliverGoods(), StationViewWindow::DrawCargoRatings(), EncodeCargoTownMonitor(), FormatString(), GenerateStationName(), AirportResolverObject::GetTown(), StationResolverObject::GetTown(), RoadStopScopeResolver::GetVariable(), MayLoadUnderExclusiveRights(), MoveBuoysToWaypoints(), MoveWaypointsToBaseStations(), and UpdateStationRating().

## ◆ train_station

TileArea BaseStation::train_station {INVALID_TILE, 0, 0}

Tile area the train 'station' part covers.

Definition at line 83 of file base_station_base.h.

Referenced by AfterLoadGame(), CanExpandRailStation(), CmdBuildRailStation(), CmdBuildRailWaypoint(), CmdRemoveFromRailStation(), Station::GetCatchmentRadius(), Station::GetTileArea(), Waypoint::GetTileArea(), Waypoint::IsSingleTile(), Station::MarkTilesDirty(), MoveBuoysToWaypoints(), Train::OnNewEconomyDay(), RemoveFromRailBaseStation(), StationResolverObject::ResolveReal(), and StationUsesDefaultType().

## ◆ waiting_random_triggers

StationRandomTriggers BaseStation::waiting_random_triggers

Waiting triggers (NewGRF), shared by all station parts/tiles, road stops, ... essentially useless and broken by design.

Definition at line 77 of file base_station_base.h.

Referenced by RoadStopScopeResolver::GetRandomTriggers(), StationScopeResolver::GetRandomTriggers(), TriggerRoadStopRandomisation(), and TriggerStationRandomisation().

## ◆ xy

TileIndex BaseStation::xy = INVALID_TILE

Base tile of the station.

Definition at line 59 of file base_station_base.h.

Referenced by Station::AddIndustryToDeliver(), LinkGraph::AddNode(), CargoPacket::AfterLoad(), AfterLoadLinkGraphs(), AircraftController(), AircraftGetEntryPoint(), CalcClosestStationTile(), CmdBuildBuoy(), CmdBuildRailWaypoint(), CmdBuildRoadWaypoint(), CmdMoveStationName(), CmdMoveWaypointName(), DeleteStaleLinks(), CompanyStationsWindow::DrawWidget(), Aircraft::FindClosestDepot(), WaypointWindow::GetCenterTile(), Order::GetLocation(), RoadVehicle::GetOrderStationLocation(), Ship::GetOrderStationLocation(), Train::GetOrderStationLocation(), GetReferenceTile(), Waypoint::GetTileArea(), LoadUnloadVehicle(), ModifyStationRatingAround(), Station::MoveSign(), Waypoint::MoveSign(), CompanyStationsWindow::OnClick(), LinkRefresher::RefreshStats(), UpdateOrderDest(), Station::UpdateVirtCoord(), and Waypoint::UpdateVirtCoord().

The documentation for this struct was generated from the following files:

- src/base_station_base.h
- src/station.cpp
- src/station_cmd.cpp